/*
 * Author: Hiroyuki Chishiro
 * License: 2-Clause BSD
 */
#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

int main(void)
{
  void *handle;
  void (*call_puts)(const char *);
  void (*call_printf)(const char *);
  char *ret;

  if ((handle = dlopen("libmyfunc.so", RTLD_LAZY)) == NULL) {
    fprintf(stderr, "%s\n", dlerror());
    exit(1);
  }

  dlerror();

  *(void **) &call_puts = dlsym(handle, "call_puts");
  *(void **) &call_printf = dlsym(handle, "call_printf");
  
  if ((ret = dlerror()) != NULL) {
    fprintf(stderr, "%s\n", ret);
    exit(2);
  }

  (*call_puts)("puts()\n");
  (*call_printf)("printf()\n");

  if (dlclose(handle) != 0) {
    fprintf(stderr, "%s\n", dlerror());
    exit(3);
  }

  return 0;
}
